using System;

namespace HogeHogeCube
{
	/// <summary>
	/// L[uf[^
	/// </summary>
	public class Cube
	{
		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="size">TCYiӂ̕j</param>
		public Cube(int size)
		{
			init(size);
		}

		/// <summary>
		/// f[^̏
		/// </summary>
		/// <param name="size">TCYiӂ̕j</param>
		public void init(int size)
		{
			m_size  = size;
			m_faces = new FaceData[Faces];

			// f[^
			//  iFace ͐F iFace Ŗ߂܂
			for(int iFace = 0; iFace < Faces; ++iFace)
			{
				m_faces[iFace] = new FaceData(size, iFace);
			}

			// Aݒ
			for(int iFace = 0; iFace < Faces; ++iFace)
			{
				FaceData  node = m_faces[iFace];
				CyclicInt ciFace = new CyclicInt(Faces, iFace);
				CyclicInt ciDir  = new CyclicInt((int)Direction.Number, 0);

				Face[] next = new Face[(int)Direction.Number];

				for(int dir = 0; dir < (int)Direction.Number; ++dir)
				{
					int iNext   = ciFace + IncFace     [dir, iFace & 1];
					int dirNext = ciDir  + IncDirection[dir, iFace & 1];
					next[dir] = new Face(m_faces[iNext], (Direction)dirNext);
				}
				node.setNext(next);
			}

			m_face = new Face(m_faces[0], Direction.Up);
		}

		/// <summary>
		/// L[u_ɂP񂵂܂
		/// SƂʂƖʂ̌_ɑIсA
		/// _ɑI񂾍sE։񂵂܂
		/// </summary>
		public void shuffle()
		{
			int       iFace = random.Next(Faces);     // SƂ
			Direction dir   = (Direction)random.Next((int)Direction.Number);    // ʂ̌
			int       x     = random.Next(m_size);    // 񂷍s

			Face face = new Face(m_faces[iFace], dir);
			rotate(face, x, Direction.Right);
		}

		/// <summary>
		/// L[u̒Sʂʂ̖ʂɕύX܂
		/// </summary>
		/// <param name="face">VS</param>
		public void move(Face face)
		{
			m_face = face;
		}

		/// <summary>
		/// SƂʂA]܂
		/// </summary>
		/// <param name="dir">]</param>
		public void rotate(Direction dir)
		{
			m_face.rotate(dir);
		}

		/// <summary>
		/// L[uP񂵂܂
		///  x ́A񂷕EȂsԍɁA񂷕㉺ȂԍɂȂ܂
		/// </summary>
		/// <param name="x">ԍij</param>
		/// <param name="dir">񂷕</param>
		public void rotate(int x, Direction dir)
		{
			rotate(m_face, x, dir);
		}

		/// <summary>
		/// L[uP񂵂܂
		///  x ́A񂷕EȂsԍɁA񂷕㉺ȂԍɂȂ܂
		/// </summary>
		/// <param name="face">SƂ</param>
		/// <param name="x">ԍij</param>
		/// <param name="dir">񂷕</param>
		public void rotate(Face face, int x, Direction dir)
		{
			// ʂ dir 񂵁Ax' ڂɉ񂵂܂
			// x' ́Adir E̎ m_size - 1 - x ɂȂ܂
			// Ⴆ΁Adir EȂEɂāAx ڂɉ񂵂܂A
			//  x' sڂEɉ񂵂̂Ɠł

			face.rotateTo(dir);
			if(dir == Direction.Down || dir == Direction.Left)
			{
				x = m_size - 1 - x;
			}

			// ɉ񂵂܂
			// ̃f[^Ɉڂ܂
			int[] bufSwap = new int[m_size];
			for(int y = 0; y < m_size; ++y)
			{
				bufSwap[y] = face[x, y];
			}
			for(int iFace = 0; iFace < Curcuit - 1; ++iFace)
			{
				Face down = face.getNext(Direction.Down);
				for(int y = 0; y < m_size; ++y)
				{
					face[x, y] = down[x, y];
				}
				face = down;
			}
			for(int y = 0; y < m_size; ++y)
			{
				face[x, y] = bufSwap[y];
			}

			// [̏ꍇAׂ̖ʂ]܂
			if(x == 0)
			{
				Face next = face.getNext(Direction.Left);
				next.rotateData(Direction.Left);
			}
			else if(x == m_size - 1)
			{
				Face next = face.getNext(Direction.Right);
				next.rotateData(Direction.Right);
			}
		}

		#region tB[h
		/// <summary>
		/// ʃf[^
		/// [0][1]
		///    [2][3]
		///       [4][5]
		/// ̏ɕł܂
		/// </summary>
		private FaceData[] m_faces;

		/// <summary>
		/// TCYiӂ̕j
		/// </summary>
		private int m_size;
		public int Size
		{
			get { return m_size; }
		}

		/// <summary>
		/// SƂ
		/// </summary>
		private Face m_face;
		public Face Face
		{
			get { return m_face; }
		}

		/// <summary>
		/// 
		/// </summary>
		private static Random random = new Random();
		#endregion

		#region 萔
		/// <summary>
		/// ʂ̐  F̐
		/// </summary>
		private static readonly int Faces = 6;

		/// <summary>
		/// ̖ʂ̐
		/// </summary>
		private static readonly int Curcuit = 4;

		/// <summary>
		/// ʃCfbNXi߂鐔
		/// index1: iޕ
		/// index2: ʃCfbNX̋
		/// ʂ̌ƍšƂ i ꍇA
		/// dir ̕ɂʂ̃CfbNX i + IncFace[dir, i & 1] œ܂
		/// ʂ̌s dir2 ̕Ă
		/// i + IncDirection[dir + dir2, i & 1] ɂȂ܂
		/// </summary>
		private static readonly int[,] IncFace = {
			{ -1, -2 },    // i: 2 -> 1  3 -> 1j
			{  1,  2 },    // Ei: 2 -> 3  3 -> 5j
			{  2,  1 },    // i: 2 -> 4  3 -> 4j
			{ -2, -1 }     // i: 2 -> 1  3 -> 1j
		};

		/// <summary>
		/// CfbNXi߂鐔
		/// index1: iޕ
		/// index2: ʃCfbNX̋
		/// ʂ̌ƍšƂ i ꍇA
		/// dir ̕ɂʂ̌ IncDirection[dir, i & 1] œ܂
		/// ʂ̌s dir2 ̕Ă
		/// dir2 + IncDirection[dir + dir2, i & 1] ɂȂ܂
		/// </summary>
		private static readonly int[,] IncDirection = {
			{  0, -1 },
			{  0,  1 },
			{ -1,  0 },
			{  1,  0 }
		};
		#endregion
	}
}
