using System;
using System.Drawing;

namespace HogeHogeCube
{
	/// <summary>
	/// L[uf[^Ǘ܂
	/// </summary>
	public class CubeManager
	{
		public CubeManager(int size)
		{
			m_cube = new Cube(size);
			initFaceMap();
			initBrush();
			initOffscreen();
		}

		/// <summary>
		/// uV̏
		/// </summary>
		private void initBrush()
		{
			m_brush = new Draw.ManagedBrush[Colors.Length];

			for(int i = 0; i < Colors.Length; ++i)
			{
				m_brush[i] = new Draw.ManagedBrush(Colors[i]);
			}
		}

		/// <summary>
		/// ʃ}bv̏
		/// </summary>
		private void initFaceMap()
		{
			// ]
			m_faceMap[0, 0] = new Face(null, Direction.Left);
			m_faceMap[2, 0] = new Face(null, Direction.Right);
			m_faceMap[3, 0] = new Face(null, Direction.Right);
			m_faceMap[0, 2] = new Face(null, Direction.Left);
			m_faceMap[2, 2] = new Face(null, Direction.Right);
			m_faceMap[3, 2] = new Face(null, Direction.Right);

			updateFaceMap();
		}

		/// <summary>
		/// ItXN[obt@̏
		/// </summary>
		public void initOffscreen()
		{
			m_offs = new Draw.Offscreen(ScreenWidth, ScreenHeight, m_brushBack);

			drawRotate();
			drawFrame();
			draw();
		}

		/// <summary>
		/// ʃ}bvXV
		/// </summary>
		public void updateFaceMap()
		{
			Face center = m_cube.Face;
			Face right  = center.getNext(Direction.Right);

				m_faceMap[1, 0] = center.getNext(Direction.Up);
			m_faceMap[0, 1] = center.getNext(Direction.Left);
				m_faceMap[1, 1] = center;
					m_faceMap[2, 1] = right;
						m_faceMap[3, 1] = right.getNext(Direction.Right);
				m_faceMap[1, 2] = center.getNext(Direction.Down);
		}

		/// <summary>
		/// Vbt
		/// </summary>
		public void shuffle()
		{
			m_cube.shuffle();
			updateFaceMap();
		}

		/// <summary>
		/// L[u̒Sʂʂ̖ʂɕύX܂
		/// </summary>
		/// <param name="face">VS</param>
		/// <returns>XV true Ԃ܂</returns>
		private bool move(Face face)
		{
			// ɒSɂȂĂΉȂ
			if(face == m_cube.Face)
			{
				return false;
			}

			m_cube.move(face);
			updateFaceMap();
			return true;
		}

		/// <summary>
		/// L[u]
		/// </summary>
		/// <param name="dir">]</param>
		/// <returns>XV true Ԃ܂</returns>
		private bool rotate(Direction dir)
		{
			// ォ Numbeȑꍇ͉܂
			if(dir == Direction.Up || dir == Direction.Number)
			{
				return false;
			}

			m_cube.rotate(dir);
			updateFaceMap();
			return true;
		}

		/// <summary>
		/// L[uP񂵂܂
		///  x ́A񂷕EȂsԍɁA񂷕㉺ȂԍɂȂ܂
		/// </summary>
		/// <param name="x">ԍij</param>
		/// <param name="dir">񂷕</param>
		/// <returns>XV true Ԃ܂</returns>
		private bool rotate(Face face, int x, Direction dir)
		{
			// Numbeȑꍇ͉܂
			if(dir == Direction.Number)
			{
				return false;
			}

			m_cube.rotate(face, x, dir);
			// ʃ}bv͕ω܂
			return true;
		}

		/// <summary>
		/// EɈ]
		/// </summary>
		/// <param name="x">sԍ</param>
		/// <param name="move">ƍɁAƉEɈړ܂</param>
		/// <returns>XV true Ԃ܂</returns>
		private bool rotateLR(Face face, int x, int move)
		{
			return rotate(face, x, move < 0 ? Direction.Left : Direction.Right);
		}

		/// <summary>
		/// ㉺Ɉ]
		/// </summary>
		/// <param name="x">ԍ</param>
		/// <param name="move">ƏɁAƉɈړ܂</param>
		/// <returns>XV true Ԃ܂</returns>
		private bool rotateUD(Face face, int x, int move)
		{
			return rotate(face, x, move < 0 ? Direction.Up : Direction.Down);
		}

		#region `
		/// <summary>
		/// L[u`
		/// </summary>
		public void draw()
		{
			for(int x = 0; x < MapWidth; ++x)
			{
				for(int y = 0; y < MapHeight; ++y)
				{
					drawFace(m_faceMap[x, y], x, y);
				}
			}
		}

		/// <summary>
		/// ʂ`
		/// </summary>
		/// <param name="face"></param>
		/// <param name="xFace">ʂ x W</param>
		/// <param name="yFace">ʂ y W</param>
		private void drawFace(Face face, int xFace, int yFace)
		{
			if(face.Void)
			{
				return;
			}

			xFace = xFace * (FaceWidth  + FaceInterval) + FaceInterval;
			yFace = yFace * (FaceHeight + FaceInterval) + FaceInterval;

			for(int x = 0; x < m_cube.Size; ++x)
			{
				for(int y = 0; y < m_cube.Size; ++y)
				{
					drawCell(xFace, yFace, x, y, face[x, y]);
				}
			}
		}

		/// <summary>
		/// ZiP}Xj`
		/// </summary>
		/// <param name="xFace">ʂ x W</param>
		/// <param name="yFace">ʂ y W</param>
		/// <param name="xCell">Z x W</param>
		/// <param name="yCell">Z y W</param>
		/// <param name="color">Fԍ</param>
		private void drawCell(int xFace, int yFace, int xCell, int yCell, int color)
		{
			Graphics g = m_offs.Graphics;

			int x = xFace + xCell * CellWidth;
			int y = yFace + yCell * CellHeight;

			g.FillRectangle(m_brush[color], x, y, CellWidth, CellHeight);
			g.DrawRectangle(m_penCellFrame, x, y, CellWidth, CellHeight);
		}

		/// <summary>
		/// ]}[N`
		/// </summary>
		private void drawRotate()
		{
			Bitmap bmpRotateL = new Bitmap(FileRotateL);

			drawRotate(bmpRotateL, 0, 0, Direction.Left);
			drawRotate(bmpRotateL, 0, 2, Direction.Left);
			drawRotate(bmpRotateL, 2, 0, Direction.Right);
			drawRotate(bmpRotateL, 2, 2, Direction.Right);
		}

		/// <summary>
		/// ]}[N`
		/// </summary>
		/// <param name="bmpRotateL">̉]}[N</param>
		/// <param name="x">}bv x W</param>
		/// <param name="y">}bv y W</param>
		/// <param name="dir">]</param>
		private void drawRotate(Bitmap bmpRotateL, int x, int y, Direction dir)
		{
			// ʂ̒S_摜̃TCY̔炷
			x = x * (FaceWidth  + FaceInterval) + FaceInterval + (FaceWidth  - bmpRotateL.Width ) / 2;
			y = y * (FaceHeight + FaceInterval) + FaceInterval + (FaceHeight - bmpRotateL.Height) / 2;

			if(dir == Direction.Left)
			{
				m_offs.Graphics.DrawImage(bmpRotateL, x, y);
			}
			else
			{
				m_offs.Graphics.DrawImage(bmpRotateL, x + bmpRotateL.Width, y, -bmpRotateL.Width, bmpRotateL.Height);
			}
		}

		/// <summary>
		/// ʂ̘g`
		/// </summary>
		private void drawFrame()
		{
			for(int x = 0; x < MapWidth; ++x)
			{
				int xFace = x * (FaceWidth + FaceInterval) + FaceInterval;

				for(int y = 0; y < MapHeight; ++y)
				{
					if(m_faceMap[x, y].Void)
					{
						continue;
					}

					int yFace = y * (FaceHeight + FaceInterval) + FaceInterval;

					for(int i = 1; i <= FaceInterval; ++i)
					{
						m_offs.Graphics.DrawRectangle(
							m_penFaceFrame,
							xFace - i, yFace - i, FaceWidth + i * 2, FaceHeight + i * 2);
					}
				}
			}
		}
		#endregion

		#region }EXCxg
		/// <summary>
		/// }EXƂ̋
		/// </summary>
		public void onMouseDown(int x, int y)
		{
			// Wۑ邾
			m_anchor = new Point(x, y);
		}

		/// <summary>
		/// }EXƂ̋
		/// </summary>
		/// <returns>XV true Ԃ܂</returns>
		public bool onMouseUp(int x, int y)
		{
			Point pt     = new Point(x, y);
			Point ptMove = pt - (Size)m_anchor;

			// ܂ړĂȂꍇ̓NbNƂ݂Ȃ
			if(ptMove.X * ptMove.X + ptMove.Y * ptMove.Y <= ClickRadiusSquared)
			{
				return onClick(m_anchor);
			}
			else
			{
				return onDrag(m_anchor, pt, ptMove);
			}
		}

		/// <summary>
		/// NbNƂ̓
		/// </summary>
		/// <param name="pt">NbNʒu</param>
		/// <returns>XV true Ԃ܂</returns>
		private bool onClick(Point pt)
		{
			CubePoint ptCube = clientToFaceMap(pt);
			if(ptCube == null)
			{
				// }bvOȂ牽Ȃ
				return false;
			}

			Face face = m_faceMap[ptCube.Map.X, ptCube.Map.Y];

			if(face.Void)
			{
				// ʂȂ΁A]܂
				return rotate(face.Dir);
			}
			else
			{
				// ʂ΁A𒆐Sɂ܂
				return move(face);
			}
		}

		/// <summary>
		/// hbOƂ̓
		/// </summary>
		/// <param name="begin">n_</param>
		/// <param name="end">I_</param>
		/// <param name="ptMove">ړxNg</param>
		/// <returns>XV true Ԃ܂</returns>
		private bool onDrag(Point begin, Point end, Point ptMove)
		{
			CubePoint ptCube = clientToFaceMap(begin);
			if(ptCube == null)
			{
				// }bvOȂ牽܂
				return false;
			}

			Face face = m_faceMap[ptCube.Map.X, ptCube.Map.Y];

			if(face.Void)
			{
				// ʂȂ΁A܂
				return false;
			}
			else
			{
				// ʂ΁AP]܂
				if(Math.Abs(ptMove.X) >= Math.Abs(ptMove.Y))
				{
					// x ɑړĂ΁AEɈړ
					return rotateLR(face, ptCube.Face.Y, ptMove.X);
				}
				else
				{
					// y ɑړĂ΁A㉺Ɉړ
					return rotateUD(face, ptCube.Face.X, ptMove.Y);
				}
			}
		}

		/// <summary>
		/// NCAgWʃ}bv̍W擾܂
		/// </summary>
		/// <param name="pt">NCAgW</param>
		/// <returns>ʃ}bv̍W</returns>
		private CubePoint clientToFaceMap(Point pt)
		{
			int width  = FaceWidth  + FaceInterval;
			int height = FaceHeight + FaceInterval;

			int x = pt.X - FaceInterval;
			int y = pt.Y - FaceInterval;

			int xMap = x / width;
			int yMap = y / height;

			if(xMap < 0 || MapWidth  <= xMap ||
			   yMap < 0 || MapHeight <= yMap)
			{
				// }bvȌꍇ null Ԃ܂
				return null;
			}
			else
			{
				int xFace = x % width  / CellWidth;
				int yFace = y % height / CellHeight;

				// g̏ꍇ null Ԃ܂
				if(xFace >= m_cube.Size || yFace >= m_cube.Size)
				{
					return null;
				}

				return new CubePoint(xMap, yMap, xFace, yFace);
			}
		}
		#endregion

		#region tB[h
		/// <summary>
		/// L[uf[^
		/// </summary>
		private Cube m_cube;

		/// <summary>
		/// ʃ}bv
		/// \ʒuƖʂƂ̑ΉLq܂
		/// </summary>
		private Face[,] m_faceMap = new Face[MapWidth, MapHeight];

		/// <summary>
		/// `
		/// </summary>
		private Draw.Offscreen m_offs;
		public Bitmap Buffer
		{
			get { return m_offs.Buffer; }
		}

		/// <summary>
		/// Zh邽߂̃uV
		/// </summary>
		private Draw.ManagedBrush[] m_brush;

		/// <summary>
		/// wiuV
		/// </summary>
		private Draw.ManagedBrush m_brushBack = new Draw.ManagedBrush(Color.Gray);

		/// <summary>
		/// ZEy
		/// </summary>
		private Draw.ManagedPen m_penCellFrame = new Draw.ManagedPen(Color.Black);

		/// <summary>
		/// ʋEy
		/// </summary>
		private Draw.ManagedPen m_penFaceFrame = new Draw.ManagedPen(Color.Black);

		/// <summary>
		/// hbÕAJ[|Cg
		/// </summary>
		private Point m_anchor;

		/// <summary>
		/// ʂ̕isNZPʁj
		/// </summary>
		public int FaceWidth
		{
			get { return m_cube.Size * CellWidth; }
		}

		/// <summary>
		/// ʂ̍isNZPʁj
		/// </summary>
		public int FaceHeight
		{
			get { return m_cube.Size * CellHeight; }
		}

		/// <summary>
		/// ʂ̃TCYisNZPʁj
		/// </summary>
		public Size FaceSize
		{
			get { return new Size(FaceWidth, FaceHeight); }
		}
		#endregion

		#region 萔
		/// <summary>
		/// ʃ}bv̕
		/// </summary>
		private static readonly int MapWidth = 4;

		/// <summary>
		/// ʃ}bv̍
		/// </summary>
		private static readonly int MapHeight = 3;

		/// <summary>
		/// Z̕
		/// </summary>
		private static readonly int CellWidth  = 16;

		/// <summary>
		/// Z̍
		/// </summary>
		private static readonly int CellHeight = CellWidth;

		/// <summary>
		/// ʂ̕\Ԋu
		/// </summary>
		public static readonly int FaceInterval = 2;

		/// <summary>
		/// ʂ̍ŏTCY
		/// </summary>
		public static readonly int MinSize = 2;

		/// <summary>
		/// ʂ̍őTCY
		/// </summary>
		public static readonly int MaxSize = 10;

		/// <summary>
		/// ʂ̕
		/// </summary>
		public static readonly int ScreenWidth = MaxSize * MapWidth * CellWidth + FaceInterval * (MapWidth + 1) + 1;

		/// <summary>
		/// ʂ̍
		/// </summary>
		public static readonly int ScreenHeight = MaxSize * MapHeight * CellHeight + FaceInterval * (MapHeight + 1) + 1;

		/// <summary>
		/// Z̎ޔԍɑΉF
		/// </summary>
		private static readonly Color[] Colors = {
			Color.White,
			Color.Red,
			Color.Green,
			Color.Blue,
			Color.Yellow,
			Color.Orange
		};

		/// <summary>
		/// NbNƂ݂Ȃړa
		/// </summary>
		private static readonly int ClickRadius = 4;

		/// <summary>
		/// ClickRadius ̓
		/// </summary>
		private static readonly int ClickRadiusSquared = ClickRadius * ClickRadius;

		/// <summary>
		/// ]\OtBbÑpX
		/// </summary>
		private static readonly string FileRotateL = "RotateL.bmp";
		#endregion
	}

	/// <summary>
	/// ʃ}bv̍Wʏ̍W
	/// </summary>
	class CubePoint
	{
		/// <summary>
		/// ʃ}bv̍W
		/// </summary>
		public Point Map;

		/// <summary>
		/// ʏ̍W
		/// </summary>
		public Point Face;

		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="map">ʃ}bv̍W</param>
		/// <param name="face">ʏ̍W</param>
		public CubePoint(Point map, Point face)
		{
			Map  = map;
			Face = face;
		}

		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="xMap">ʃ}bv x W</param>
		/// <param name="yMap">ʃ}bv y W</param>
		/// <param name="xFace">ʏ x W</param>
		/// <param name="yFace">ʏ y W</param>
		public CubePoint(int xMap, int yMap, int xFace, int yFace) :
			this(new Point(xMap, yMap), new Point(xFace, yFace))
		{
		}
	}
}
